<img src="./logo.png" alt="logo"/>
<p align="center">
    <a href="https://github.com/blyndusk/tiredjs/blob/master/lib/tired.min.js">
        <img src="https://img.shields.io/github/size/blyndusk/tiredjs/lib/tired.min.js" alt="lib size"/>
    </a>
    <a href="https://www.npmjs.com/package/tiredjs">
        <img src="https://img.shields.io/npm/dw/tiredjs" alt="NPM downloads"/>
    </a>
    <a href="https://www.npmjs.com/package/tiredjs">
        <img src="https://img.shields.io/npm/v/tiredjs" alt="NPM version"/>
    </a>
    <a href="https://github.com/blyndusk/tiredjs/releases/latest">
        <img src="https://img.shields.io/github/release-date-pre/blyndusk/tiredjs" alt="latest pre-release"/>
    </a>
    <a href="https://github.com/blyndusk/tiredjs/blob/master/LICENSE">
        <img src="https://img.shields.io/github/license/blyndusk/tiredjs" alt="MIT license"/>
    </a>
</p>

# tiredjs, a solution for tired/bored front-end developers

- 💨 a **lightweight** Javascript library
- 🏁 designed to make using *DOM/basic* JS **faster** & more **intuitive**
- 💡 useful in many **specific** & **situational** cases.
- ⏱ with considerable **time** savings.
- 🌎 available on [npm](https://www.npmjs.com/package/tiredjs) & [unpkg.com](https://unpkg.com/tiredjs)

## I - TOC

- [tiredjs, a solution for tired/bored front-end developers](#tiredjs-a-solution-for-tiredbored-front-end-developers)
  - [I - TOC](#i---toc)
  - [II - Install](#ii---install)
    - [Via a CDN](#via-a-cdn)
    - [Via NPM](#via-npm)
  - [III - Examples](#iii---examples)
  - [IV - Build](#iv---build)
  - [V - License](#v---license)

## II - Install

### Via a CDN

> Always before the others scripts ⚠️

```HTML
    <script src="https://unpkg.com/tiredjs"></script>
    <script src="./src/main.js"></script>
</body>
```

### Via NPM

```bash
npm i tiredjs
```

`index.js`

```JavaScript
import 'tiredjs';

log('Hello World !');

ael(qs('button'), 'click', () => alert('Clicked !'));
```

## III - Examples

`index.js (src)`

```JavaScript
const rdmInt = int =>  Math.floor(Math.random() * int);

ready(qs('.component'), () => {

    log('Hello World !');

    ael(qs('.component-button'), 'click', () => alert('Button clicked !'));

    forl(qsa('.component ul li'), el => el.style.background = `hsl(${rdmInt(360)}, 50, 100`);
}
```

**becomes**...

`index.js (dist)`

```JavaScript

const rdmInt = int =>  Math.floor(Math.random() * int);

document.addEventListener('DOMContentLoaded', () => {
    if (document.querySelector('.component')) () => {
        console.log('Hello World !');
        document.querySelector('.component-button').addEventListener('click', () => alert('Button clicked !'));
        for (let i = 0; i < document.querySelectorAll('.component ul li').length; i++) {
            const el = document.querySelectorAll('.component ul li')[i];
            el.style.background = `hsl(${rdmInt(360)}, 50, 100`;
        }
    }
})
```

## IV - Build

```bash
npm run build
```

## V - License

Under [MIT](https://github.com/blyndusk/tiredjs/blob/master/LICENSE) license.
